#ifndef DRUMS_H_INCLUDED
#define DRUMS_H_INCLUDED

#include <stdint.h>
#include "settings.h"
void drums_init(void);
void drums_start(void);
void drums_stop(void);
int drums_get(uint32_t track, int pos);
void drums_set(uint32_t track, int pos);
void drums_clear(uint32_t track, int pos);
void drums_oneshot(int track);
void drums_select_pattern(struct drums_pattern *p);

#define DRUMS_KICK      (1 << 0)
#define DRUMS_HIHAT     (1 << 1)
#define DRUMS_SNARE     (1 << 2)
#define DRUMS_TOM1      (1 << 3)
#define DRUMS_TOM2      (1 << 4)
#define DRUMS_CYM       (1 << 5)
#define DRUMS_CLAP      (1 << 6)
#endif
