MEMORY
{
    FLASH (rx) : ORIGIN = 0x00000000, LENGTH = 256K - 0x100
    RAM_S (rw) : ORIGIN = 0x20000000, LENGTH = 4K
    RAM (rw) : ORIGIN = 0x20001000, LENGTH = 64K
    RAM_SETTINGS (rw) : ORIGIN = 0x2012000, LENGTH = 60K
}

SECTIONS
{
    .text :
    {
        _start_text = .;
        KEEP(*(.isr_vector))
        *(.text*)
        *(.rodata*)
        . = ALIGN(4);
        _end_text = .;
    } > FLASH

    .edidx :
    {
        . = ALIGN(4);
        *(.ARM.exidx*)
    } > FLASH

    _stored_data = .;


    .data : AT (_stored_data)
    {
        _start_data = .;
        *(.data*)
        . = ALIGN(4);
        _end_data = .;
    } > RAM

    .bss :
    {
        _start_bss = .;
        *(.bss*)
        *(COMMON)
        . = ALIGN(4);
        _end_bss = .;
        _end = .;
    } > RAM
    
    .settings :
    {
        *(.settings*)
    } > RAM_SETTINGS

}

PROVIDE(_start_heap = _end);
PROVIDE(_end_stack  = ORIGIN(RAM_S) + LENGTH(RAM_S));
